/*****************************************************************************
Author: Constantin Musca 332CA
First Written: 15.05.2011

Microcontroller:ATmega16
Crystal:16Mhz
*******************************************************************************/

#include <avr/io.h>		
#include <stdlib.h>
#include "128x64-text.c"

#define LEFT (1 << PC7)
#define RIGHT (1 << PC6)
#define DOWN (1 << PC5)
#define UP (1 << PC4)

#define PLEFT 0
#define PRIGHT 1
#define PUP 2
#define PDOWN 3
#define NO_PHANT 2

#define CHAR_HEIGHT 8
#define CHAR_WIDTH 5
#define SPACE 4
#define PACMAN 5
#define WALL 0
#define PHANTOM 6
#define PACDOT 2
#define NO_POINTS 41

char map[8][16] = { 
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,2,2,0,2,2,2,2,0,0,2,2,2,0,0},
{0,0,2,0,0,0,0,2,0,0,0,0,0,2,0,0},
{0,0,5,2,2,2,2,2,2,2,2,2,2,2,0,0},
{0,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0},
{0,0,0,2,0,0,0,0,0,0,2,0,0,0,0,0},
{0,2,2,2,2,2,2,2,2,2,2,2,2,2,2,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}
};


void print_map() { 
	int i,j;
	
	for(i = 0; i < 8; i++)
		for(j = 0; j < 16; j++)
			switch(map[i][j]) {
				case 0: 
					lcd_writech('#');
					break;
				case 2:
					lcd_writech('\'');
					break;
				case 4:
					lcd_writech(' ');
					break;
				case 5:
					lcd_writech('@');
					break;
				case PHANTOM:
					lcd_writech('Z');
					
			
			
			
			}
}


int main (void)
{
	int i, j, time = 0, k, lost = 0, points = 0;
	
	int xphantoms[NO_PHANT];
	int yphantoms[NO_PHANT];
	int phantom_hide[NO_PHANT];
	int phantom_dir[NO_PHANT];

	lcdInit();
	clearl();
	PORTC = 240;
	DDRC = 0;
	
	/* pozitia initiala pacman */
	i = 3;
	j = 2;
	
	/* initializare fantome */
	xphantoms[0] = 3;
	yphantoms[0] = 7;
	phantom_dir[0] = PLEFT;
	phantom_hide[0] = PACDOT;
	
	xphantoms[1] = 6;
	yphantoms[1] = 2;
	phantom_dir[1] = PRIGHT;
	phantom_hide[1] = PACDOT;
	
	for(k = 0; k < NO_PHANT; k++) {
		map[xphantoms[k]][yphantoms[k]] = PHANTOM;
	}
	
	

	setXY(0,0);
	print_map();
	
	
	while(1) {
		
		/* verific butoanele si misc Pacman-ul */
		
		if (!(PINC & LEFT)) {
			
 
			if ( (j >= 1) && (map[i][j-1] != 0)) {

				if(map[i][j-1] == PHANTOM) { 
					lost = 1;
				
				}
				
				map[i][j] = SPACE;
				j--;
				if (map[i][j] == PACDOT) { 
					points++;
				}
				map[i][j] = PACMAN;
				
				
			
			} 
			
		}
		if (!(PINC & RIGHT)) {
			if ( (j < 15) && (map[i][j+1] != 0)) {
			
				if(map[i][j+1] == PHANTOM) { 
					lost = 1;
				
				}
				
				
				map[i][j] = SPACE;
				j++;
				if (map[i][j] == PACDOT) { 
					points++;
				}
				map[i][j] = PACMAN;
			
			} 
 
			
		}
		if (!(PINC & UP)) {
			if ( (i >= 1) && (map[i-1][j] != 0)) {
			
				if(map[i-1][j] == PHANTOM) { 
					lost = 1;
				
				}

				map[i][j] = SPACE;
				i--;
				if (map[i][j] == PACDOT) { 
					points++;
				}
				map[i][j] = PACMAN;
			
			} 
			
		}
		if (!(PINC & DOWN)) { 
			if ( (i < 7) && (map[i+1][j] != 0)) {
				if(map[i+1][j] == PHANTOM) { 
					lost = 1;
				
				}

				map[i][j] = SPACE;
				i++;
				if (map[i][j] == PACDOT) { 
					points++;
				}
				map[i][j] = PACMAN;
			
			} 
			
		}
		
		/* verific daca jocul este pierdut */
		if (lost) {
			clearl();
			setXY(0,0);
			printl("you lost man");
			break;
		
		}
		if (points == NO_POINTS) {
			clearl();
			setXY(0,0);
			printl("you won");
			break;
			
		}
		
		
		time++;
		if (time == 20) { 
			time = 0;
			
			/* misc fantomele */
			for(k = 0; k < NO_PHANT; k++) { 
			
				switch(phantom_dir[k]) {
					case PLEFT:
			
						if ( (yphantoms[k] >= 1) && (map[xphantoms[k]][yphantoms[k] - 1] != 0) && (map[xphantoms[k]][yphantoms[k] - 1] != PHANTOM)) { 
							map[xphantoms[k]][yphantoms[k]] = phantom_hide[k];
							yphantoms[k]--;
							
							if (map[xphantoms[k]][yphantoms[k]] == PACMAN) { 
								lost = 1;
							}
							phantom_hide[k] = map[xphantoms[k]][yphantoms[k]];
							map[xphantoms[k]][yphantoms[k]] = PHANTOM;
							
							break;
						
						}
						else
							phantom_dir[k] = rand() % 4;
							
					case PRIGHT:
						if ( (yphantoms[k] < 15) && (map[xphantoms[k]][yphantoms[k] + 1] != 0) && (map[xphantoms[k]][yphantoms[k] + 1] != PHANTOM)) { 
							map[xphantoms[k]][yphantoms[k]] = phantom_hide[k];
							yphantoms[k]++;
							
							if (map[xphantoms[k]][yphantoms[k]] == PACMAN) { 
								lost = 1;
							}
							phantom_hide[k] = map[xphantoms[k]][yphantoms[k]];
							map[xphantoms[k]][yphantoms[k]] = PHANTOM;
							break;
						
						}
						else
							phantom_dir[k] = rand() % 4;
					
					case PUP:
					
						if ( (xphantoms[k] >= 1) && (map[xphantoms[k]-1][yphantoms[k]] != 0) && (map[xphantoms[k] - 1][yphantoms[k]] != PHANTOM)) { 
							map[xphantoms[k]][yphantoms[k]] = phantom_hide[k];
							xphantoms[k]--;
							
							if (map[xphantoms[k]][yphantoms[k]] == PACMAN) { 
								lost = 1;
							}
							phantom_hide[k] = map[xphantoms[k]][yphantoms[k]];
							map[xphantoms[k]][yphantoms[k]] = PHANTOM;
							break;
						
						}
						else
							phantom_dir[k] = rand() % 4;
					
					case PDOWN:
						
						if ( (xphantoms[k] < 7) && (map[xphantoms[k]+1][yphantoms[k]] != 0) && (map[xphantoms[k]+1][yphantoms[k]] != PHANTOM)) { 
							map[xphantoms[k]][yphantoms[k]] = phantom_hide[k];
							xphantoms[k]++;
							
							if (map[xphantoms[k]][yphantoms[k]] == PACMAN) { 
								lost = 1;
							}
							phantom_hide[k] = map[xphantoms[k]][yphantoms[k]];
							map[xphantoms[k]][yphantoms[k]] = PHANTOM;
							break;
						
						}
						else
							phantom_dir[k] = rand() % 4;
				}
			
			}
			
		}
		
		if (lost) {
			clearl();
			setXY(0,0);
			printl("you lost man");
			break;
		
		}
		
		setXY(0,0);
		print_map();
		_delay_ms(100);
		
		
		
	}
	
	
	return 0;
	
}


